// <clown> csc.exe /debug+ /t:library /r:FlexiGen.dll Ensenada.cs </clown>

using System;
using System.Xml;
using System.IO;
using System.Net;
using FlexiGen;

namespace Ensenada {

public class HttpSource : SourceBase {

private string m_Url;
private string m_TemplateText;

#region "Init/Fin"
public HttpSource() : base() {

}
#endregion


#region "Properties"

#endregion


#region "Methods"
public override void Initialize(Generator generator, XmlElement xe){
    base.Initialize(generator, xe);
	m_Url = xe.Attributes["url"].Value;
}
public override string GetTemplateText(){
	if(m_TemplateText == null){
        StreamReader reader = null;		
 
		try{
			WebResponse wresp = null;
            WebRequest wr = null;            

            wr = WebRequest.Create(m_Url);
            wresp = wr.GetResponse();
            Stream stream = wresp.GetResponseStream();
            reader = new StreamReader(stream);
            m_TemplateText = reader.ReadToEnd();
            
		}finally{
			if(reader != null)
				reader.Close();
		}
	}
	return m_TemplateText;
}
#endregion


}

}