using System;
using System.Reflection;
using System.Xml;

namespace FlexiGen {

public class AddIn {


#region "Static stuff"

#endregion


#region "Encapsulation"
private Generator m_Generator;
private string m_AssemblyName;
private Assembly m_Assembly;
#endregion


#region "Init/Fin"
internal AddIn(Generator generator, XmlElement xe) {
	m_Generator = generator;
	m_AssemblyName = generator.FindAttribute(xe, "assembly");
}
#endregion


#region "Event handlers"

#endregion


#region "Event raisers"

#endregion


#region "Properties"
public Generator Generator{
	get{
		return m_Generator;
	}
}
public Assembly Assembly{
	get{
		this.LoadAssembly();
		return m_Assembly;
	}
}
#endregion


#region "Methods"
internal void LoadAssembly(){
	if(m_Assembly == null){
		m_Assembly = Assembly.LoadFrom(m_AssemblyName);
	}
}
#endregion


#region "Helpers"

#endregion


} // end class AddIn

} // end namespace FlexiGen
