using System;
using System.IO;
using System.Xml;

namespace FlexiGen {

public class FileSource : SourceBase {


#region "Static stuff"

#endregion


#region "Encapsulation"
private string m_File;
private string m_TemplateText;
#endregion


#region "Init/Fin"
public FileSource() : base() {
	
}
#endregion


#region "Event handlers"

#endregion


#region "Event raisers"

#endregion


#region "Properties"

#endregion


#region "Methods"
public override void Initialize(Generator generator, XmlElement xe){
	base.Initialize(generator, xe);
	m_File = generator.FindAttribute(xe, "file");
}
public override string GetTemplateText(){
	if(m_TemplateText == null){
		StreamReader reader = null;
		try{
			reader = new StreamReader(File.OpenRead(m_File));
			m_TemplateText = reader.ReadToEnd();
		}finally{
			if(reader != null)
				reader.Close();
		}
	}
	return m_TemplateText;
}
#endregion


#region "Helpers"

#endregion


} // end class FileSource

} // end namespace FlexiGen
